import Blender

def SaveMeshFaces(mesh):
	tempfaces = [];
  	for f in mesh.faces:
    		if (len(f.v)==3):
      			tempfaces.append(f);
			
  	file.write("faces %i\n" % len(tempfaces))
	for f in tempfaces:
		for i in range(len(f.v)):
			file.write("%i " %  f.v[i].index)
			file.write("\n")  
			
def SaveMeshVerts(mesh):
  	file.write("vertices %i\n" % len(mesh.verts))
	for v in mesh.verts:
		file.write("%f %f %f\n" % (v.co.x, v.co.y, v.co.z))
		file.write("%f %f %f\n" % (v.no.x, v.no.y, v.no.z))
		file.write("%f %f\n"    % (v.uvco.x, v.uvco.y))

def SaveLocRotSize(object):	
	file.write("Loc %f %f %f\n" % (object.LocX,object.LocY,object.LocZ))
	file.write("Rot %f %f %f\n" % (object.RotX,object.RotY,object.RotZ))
  	file.write("Size %f %f %f\n" % (object.SizeX,object.SizeY,object.SizeZ))
	
def SaveObjectHeader(object_name):
	mesh = Blender.NMesh.GetRawFromObject(object_name)
	file.write("object %s\n" % object_name)
	file.write("mesh %s\n" % mesh.name)
	SaveMeshFaces(mesh)

def SaveObject(frame,object_name):
    	Blender.Set('curframe',frame)
	object = Blender.Object.Get(object_name)
	mesh = Blender.NMesh.GetRawFromObject(object.name)
	file.write("\nframe %i\n" % Blender.Get('curframe'))
	SaveLocRotSize(object)
	SaveMeshVerts(mesh)

file = open("scene","w")
file.write("DecopterMetaMesh\n")
file.write("frames: %i\n" % Blender.Get('endframe'))
file.write("meshes %i\n" % len(Blender.Object.getSelected()))
for object in Blender.Object.getSelected():
	SaveObjectHeader(object.name)
	for frame in range(Blender.Get('staframe'),Blender.Get('endframe')+1):	
		SaveObject(frame,object.name)
file.write("EndOfMeshes\n");
file.close();
