# decopter meshes export script by Jacek Poplawski
# http://decopter.sourceforge.net

import Blender

file=open("scene","w")
file.write("DecopterMetaMesh\n")

file.write("meshes %i\n" % len(Blender.Object.getSelected()))

for object in Blender.Object.getSelected():

  file.write("mesh %s\n" % object.data.name)

  file.write("Loc %f %f %f\n" %  (object.LocX, object.LocY, object.LocZ))
  file.write("Rot %f %f %f\n" %  (object.RotX, object.RotY, object.RotZ))
  file.write("Size %f %f %f\n" %  (object.SizeX, object.SizeY, object.SizeZ))

  mesh=object.data
  
  # if mesh has uv coordinates it tells us the flag: 
  # mesh.has_uvco

  tempfaces=[];
  for f in mesh.faces:
    if (len(f.v)==3):
      tempfaces.append(f);
      
  file.write("vertices %i\n" % len(mesh.verts))
  file.write("faces %i\n" % len(tempfaces))

  for v in mesh.verts:
    file.write("%f %f %f\n" % (v.co.x, v.co.y, v.co.z))
    file.write("%f %f %f\n" % (v.no.x, v.no.y, v.no.z))
    file.write("%f %f\n"    % (v.uvco.x, v.uvco.y))

  for f in tempfaces:
    for i in range(len(f.v)):
      file.write ("%i " %  f.v[i].index)
    file.write("\n")  
    
file.write("EndOfMeshes\n");
file.close();

